/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VInputHelpDeDeRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VInputHelpDeDe extends TableImpl<VInputHelpDeDeRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_input_help_de_de</code>
     */
    public static final VInputHelpDeDe V_INPUT_HELP_DE_DE = new VInputHelpDeDe();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VInputHelpDeDeRecord> getRecordType() {
        return VInputHelpDeDeRecord.class;
    }

    /**
     * The column <code>common_dd.v_input_help_de_de.inputhelp</code>.
     */
    public final TableField<VInputHelpDeDeRecord, Integer> INPUTHELP = createField(DSL.name("inputhelp"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_input_help_de_de.inputhelp_descr</code>.
     */
    public final TableField<VInputHelpDeDeRecord, String> INPUTHELP_DESCR = createField(DSL.name("inputhelp_descr"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_input_help_de_de.value</code>.
     */
    public final TableField<VInputHelpDeDeRecord, String> VALUE = createField(DSL.name("value"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_input_help_de_de.needed_params</code>.
     */
    public final TableField<VInputHelpDeDeRecord, Integer> NEEDED_PARAMS = createField(DSL.name("needed_params"), SQLDataType.INTEGER, this, "");

    private VInputHelpDeDe(Name alias, Table<VInputHelpDeDeRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VInputHelpDeDe(Name alias, Table<VInputHelpDeDeRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_input_help_de_de" as  SELECT t_input_help.inputhelp,
          t_input_help.inputhelp_descr,
          t_core_translation.value,
          t_input_help.needed_params
         FROM (common_dd.t_input_help
           LEFT JOIN common_dd.t_core_translation ON (((t_core_translation.fk_trans_key = t_input_help.inputhelp_descr) AND (t_core_translation.isocode = 'de_DE'::common_dd.enum_isocode) AND (t_core_translation.category = 'crf'::common_dd.enum_trans_category))))
        ORDER BY t_input_help.inputhelp;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_input_help_de_de</code> table
     * reference
     */
    public VInputHelpDeDe(String alias) {
        this(DSL.name(alias), V_INPUT_HELP_DE_DE);
    }

    /**
     * Create an aliased <code>common_dd.v_input_help_de_de</code> table
     * reference
     */
    public VInputHelpDeDe(Name alias) {
        this(alias, V_INPUT_HELP_DE_DE);
    }

    /**
     * Create a <code>common_dd.v_input_help_de_de</code> table reference
     */
    public VInputHelpDeDe() {
        this(DSL.name("v_input_help_de_de"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VInputHelpDeDe as(String alias) {
        return new VInputHelpDeDe(DSL.name(alias), this);
    }

    @Override
    public VInputHelpDeDe as(Name alias) {
        return new VInputHelpDeDe(alias, this);
    }

    @Override
    public VInputHelpDeDe as(Table<?> alias) {
        return new VInputHelpDeDe(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VInputHelpDeDe rename(String name) {
        return new VInputHelpDeDe(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VInputHelpDeDe rename(Name name) {
        return new VInputHelpDeDe(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VInputHelpDeDe rename(Table<?> name) {
        return new VInputHelpDeDe(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputHelpDeDe where(Condition condition) {
        return new VInputHelpDeDe(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputHelpDeDe where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputHelpDeDe where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputHelpDeDe where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VInputHelpDeDe where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VInputHelpDeDe where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VInputHelpDeDe where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VInputHelpDeDe where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputHelpDeDe whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputHelpDeDe whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
